      SUBROUTINE DERFOR(NDIM,X,F,DX,W,DFDX)
C
C  DERFOR  COMPUTED THE FORWARD FINITE-DIFFERNCES DIRECTIONAL
C  DERIVATIVES (CALLING  FUNCT0 )
C
      DOUBLE PRECISION X,F,DX,W,DFDX
      DOUBLE PRECISION DXF,DXFF,DXMAX,FN,S,XX
      DOUBLE PRECISION FUNCT0
      DIMENSION X(NDIM),W(NDIM)
      DIMENSION XX(100)
      DATA DXFF/1.D6/,DXF/1.D1/
      DATA DXMAX/1.D6/
C
  10  CONTINUE
  20  CONTINUE
      S = 0.D0
      DO 30 IC = 1,NDIM
         XX(IC) = X(IC)+W(IC)*DX
         S = S+(XX(IC)-X(IC))**2
  30     CONTINUE
      IF(S.GT.0.D0)GO TO 40
      DX = DX*DXFF
      GO TO 20
  40  CONTINUE
      FN = FUNCT0(NDIM,XX)
      DFDX = (FN-F)/DX
      IF(DX.GT.DXMAX)RETURN
      IF(DABS(DFDX).GT.1.D0)RETURN
      IF(DFDX**2.GT.0.D0)GO TO 50
      DX = DX*DXF
      GO TO 10
  50  CONTINUE
C
      RETURN
      END
