#include        <stdio.h>
#include        <stdlib.h>
#include	<time.h>
#include        <math.h>
#include        "globdef.h"

#define MAXNC 12

static double   zero=0.0,one=1.0,two=2.0,ten=10.0;
static void (*aktfgv)(double *,double *,int *,int *);

int GLOBAL(fp,amin,amax,nparm,m,n100,ng0,fw,nsig,x0,nc,f0,nfe)
S_fp fp;
int  	  *nparm, *m, *n100, *ng0, *nsig, *nc , *nfe;
double     f0[21];
VEKTOR_n   amin, amax;
FILE       *fw;
TOMB_nx21  x0;
{
	     int     i,ng,ns,ncp,n0,n1,im,ig,n,inum,inum1,inum2,nn100,nfe1;
             int     ng10,maxfn,nm,i1,j,jj,icc,in1,iii,ii,l1,icj,iv,it;
             int     ic[101],ic1[21];
	     int     iseed;
	     double    d,b1,alfa,fm,bb,fc,a,relcon,ff,b;
             double    f[101],f1[21],fcl[101];

             VEKTOR_n  w, y, minx, maxx;

             TOMB_nx101 x, xcl, r;
             TOMB_nx21  x1;

	     /* init duni_ */
	     iseed = time(NULL);
	     dustar_(&iseed);
	     aktfgv = fp;
	     
             if((x   = (TOMB_nx101)malloc(sizeof(double)*(*nparm+1)*101))==NULL) return 3;
             if((x1  = (TOMB_nx21 )malloc(sizeof(double)*(*nparm+1)*21))==NULL) return 3;
             if((xcl = (TOMB_nx101)malloc(sizeof(double)*(*nparm+1)*101))==NULL) return 3;
             if((r   = (TOMB_nx101)malloc(sizeof(double)*(*nparm+1)*101))==NULL) return 3;

             if((w   = (VEKTOR_n)malloc(sizeof(double)*(*nparm+1)))==NULL) return 3;
             if((y   = (VEKTOR_n)malloc(sizeof(double)*(*nparm+1)))==NULL) return 3;
             if((minx = (VEKTOR_n)malloc(sizeof(double)*(*nparm+1)))==NULL) return 3;
             if((maxx = (VEKTOR_n)malloc(sizeof(double)*(*nparm+1)))==NULL) return 3;

             if (*nparm <= 0) {
		 fprintf(fw, "error: nparm <= 0");
		 goto label_460;
	     }
             if (*nparm  > 15) goto label_455;
             if (*m  > 100) {
		 fprintf(fw, "error: m > 100");
		 goto label_460;
	     }
	     
             for(i=1;i<=*nparm;i++) {
                 minx[i] = amin[i];
                 maxx[i] = amax[i];
                 if (minx[i] == maxx[i]) {
		     fprintf(fw, "error: minx = maxx");
		     goto label_460;
		 }
             }
             d = (two*sqrt((double)*nparm))*.000001;
             b1 = one/(double)*nparm;
             if (*ng0  < 1) *ng0 = 1;
             if (*ng0  > 20) *ng0 = 20;
             if (*n100  < 20) *n100 = 20;
             if (*n100  > 10000) *n100 = 10000;
             if (*n100 >= 100) goto label_10;
             nn100 = *n100;
             n = 1;
             goto label_15;
  label_10:  nn100 = 100;
             n = *n100/100;
             *n100 = n*100;
  label_15:  ng10 = 100;
             for(i=1;i<=ng10;i++) {
                 f[i] =9.9e10;
                 ic[i] = 0;
             }
             for(i=1;i<=*nparm;i++) {
                 maxx[i]= (maxx[i]-minx[i])/two;
                 minx[i]= minx[i]+maxx[i];
             }
             alfa = .01;
             *nfe = 0;
             ng = 0;
             ns = 0;
             *nc = 0;
             ncp = 1;
             n0 = 0;
             n1 = 0;
             im = 1;
             ig = 0;
             fm = 9.9e10;
             maxfn = 500**nparm;
             relcon = pow(ten,-*nsig);
/*            SAMPLING                                                   */
  label_20:  n0 = n0+*n100;
             nm = n0-1;
             ng = ng+*ng0;
             ns = ns+1;
             if (ns*(*ng0) > 100) goto label_465;
             b = pow(one-pow(alfa,one/(double)nm),b1);
             bb = 0.1*b;
             for(i1=1;i1<=n;i1++) {
                 urdmn(r,nparm);
                 for(j=1;j<=nn100;j++) {
                     for(i=1;i<=*nparm;i++) {
                         y[i] = two* (*r)[i][j]-one;
                     }
                     fun(y,&fc,nparm,m,minx,maxx);
                     if (fc >= fm) continue;
                     f[im] = fc;
                     for(i=1;i<=*nparm;i++) {
                         (*x)[i][im] = y[i];
                     }
                     if (im <= ng &&  ic[im]  > 0) ig = ig-1;
                     ic[im] = 0;
                     im = 1;
                     fm = f[1];
                     for(i=2;i<=ng10;i++) {
                         if (f[i]  < fm) continue;
                         im = i;
                         fm = f[i];
                     }
                 }
             }
  label_40:  *nfe = *nfe+*n100;
                 fprintf(fw,"\n %5d  function evaluations used for sampling",*n100);
				/*   printf("\n %5d  function evaluations used for sampling\n",*n100); */
/*           SORTING                                                     */
             inum = ng10-1;
             for(i=1;i<=inum;i++) {
                 im = i;
                 fm = f[i];
                 inum1 = i+1;
                 for(j=inum1;j<=ng10;j++) {
                     if (f[j] >= fm) continue;
                     im = j;
                     fm = f[j];
                 }
                 if (im <= i) continue;
                 a = fm;
                 for(j=1;j<=*nparm;j++) {
                     y[j] = (*x)[j][im];
                 }
                 if (i  > ng || im <= ng) goto label_55;
                 if (ic[ng] == 0 &&  ic[im]  > 0) ig = ig+1;
                 if (ic[ng]  > 0 &&  ic[im] == 0) ig = ig-1;
   label_55:     icc = ic[im];
                 inum1 = im-i;
                 for(j=1;j<=inum1;j++) {
                     inum2 = im-j;
                     f[inum2+1] = f[inum2];
                     ic[inum2+1]= ic[inum2];
                     for(jj=1;jj<=*nparm;jj++) {
                         (*x)[jj][inum2+1] = (*x)[jj][inum2];
                     }
                 }
                 f[i] =a;
                 for(j=1;j<=*nparm;j++) {
                     (*x)[j][i] = y[j];
                 }
                 ic[i] = icc;
             }
             if (*nc <= 0) goto label_200;
/*        CLUSTERING TOX*                                                */
             for(iii=1;iii<=*nc;iii++) {
                 i = 1;
                 in1 = i;
                 fcl[i]= f0[iii];
                 for(j=1;j<=*nparm;j++) {
                     (*xcl)[j][i] = (*x0)[j][iii];
                 }
                 for(j=1;j<=ng;j++) {
                     if (ic[j] != iii) continue;
                     in1 = in1+1;
                     for(ii=1;ii<=*nparm;ii++) {
                         (*xcl)[ii][in1]= (*x)[ii][j];
                     }
                 }
  label_95:      for(j=1;j<=ng;j++) {
                     if (ic[j] != 0)  continue;
                     if (fcl[i] >= f[j]) continue;
                     for(l1=1;l1<=*nparm;l1++) {
                         w[l1] = fabs((*xcl)[l1][i]-(*x)[l1][j]);
                     }
                     a =zero;
                     for(l1=1;l1<=*nparm;l1++) {
                         if (w[l1]  > a) a=w[l1];
                     }
                     if (a >= b) continue;
                     fprintf(fw,"\n sample point added to the cluster no. %2d",iii);
                     for(ii=1;ii<=*nparm;ii++) {
                         w[ii]=(*x)[ii][j]*maxx[ii]+minx[ii];
                     }
                                         fprintf(fw,"\n %14.8g\n  ",f[j]);;
                     for(ii=1;ii<=*nparm;ii++) {
                        fprintf(fw," %14.8g",w[ii]);;
                        if(ii==5 || ii==10 || ii==15) fprintf(fw,"\n  ");
                     }
                     ig = ig+1;
                     if (ig >= ng) goto label_395;
                     in1= in1+1;
                     fcl[in1] = f[j];
                     for(ii=1;ii<=*nparm;ii++) {
                         (*xcl)[ii][in1]=(*x)[ii][j];
                     }
                     ic[j] = iii;
                 }
                 i = i+1;
                 if (i <= in1) goto label_95;
             }
             if (n1 <= 0) goto label_200;
/*        CLUSTERING TOX1                                                */
             for(iii=1;iii<=n1;iii++) {
                 i = 1;
                 in1 = i;
                 fcl[i]= f1[iii];
                 for(j=1;j<=*nparm;j++) {
                     (*xcl)[j][i] = (*x1)[j][iii];
                 }
  label_155:     for(j=1;j<=ng;j++) {
                     if (ic[j] != 0) continue;
                     if (fcl[i] >= f[j]) continue;
                     for(l1=1;l1<=*nparm;l1++) {
                         w[l1] = fabs((*xcl)[l1][i]-(*x)[l1][j]);
                     }
                     a =zero;
                     for(l1=1;l1<=*nparm;l1++) {
                         if (w[l1]  > a) a=w[l1];
                     }
                     if (a >= b) continue;
                         fprintf(fw,"\n sample point added to the cluster no. %d",ic1[iii]);
						/*   printf("\n sample point added to the cluster no. %d\n",ic1[iii]); */
                     for(ii=1;ii<=*nparm;ii++) {
                         w[ii] = (*x)[ii][j]*maxx[ii]+minx[ii];
                     }
                                         fprintf(fw,"\n %14.8g\n  ",f[j]);;
                     for(ii=1;ii<=*nparm;ii++) {
                         fprintf(fw," %14.8g",w[ii]);
                         if(ii==5 || ii==10 || ii==15) fprintf(fw,"\n  ");
                     }
                     ig = ig+1;
                     if (ig >= ng) goto label_395;
                     in1= in1+1;
                     fcl[in1] = f[j];
                     for(ii=1;ii<=*nparm;ii++) {
                         (*xcl)[ii][in1] = (*x)[ii][j];
                     }
                     ic[j]=ic1[iii];
                 }
                 i = i+1;
                 if (i <= in1) goto label_155;
             }
/*        LOCALSEARCH                                                    */
  label_200: it = 0;
             for(i1=1;i1<=ng;i1++) {
                 if (ic[i1] != 0) continue;
                 for(i=1;i<=*nparm;i++) {
                     y[i] = (*x)[i][i1];
                 }
                 ff = f[i1];
		/*   printf("   >> Local Search\n"); */
                 local(m,nparm,&relcon,&maxfn,y,&ff,&nfe1,minx,maxx);
                 if (*nc <= 0) goto label_290;
                 for(iv=1;iv<=*nc;iv++) {
                     for(l1=1;l1<=*nparm;l1++) {
                         w[l1] = fabs((*x0)[l1][iv]-y[l1]);
                     }
                     a =zero;
                     for(l1=1;l1<=*nparm;l1++) {
                         if (w[l1]  > a) a=w[l1];
                     }
                     if (a  < bb) goto label_255;
                 }
                 goto label_290;
/*          NEWSEED-POINT                                                */
  label_255:     n1 = n1+1;
                 fprintf(fw,"\n new seed point added to the cluster no %d nfev= %d",iv,nfe1);
                 for(ii=1;ii<=*nparm;ii++) {
                     w[ii] = (*x)[ii][i1]*maxx[ii]+minx[ii];
                 }
                 fprintf(fw,"\n %14.8g\n  ",ff);
                 for(ii=1;ii<=*nparm;ii++) {
                          fprintf(fw," %14.8g",w[ii]);
                      if(ii==5 || ii==10 || ii==15) fprintf(fw,"\n  ");
                 }
                 if (ff >= f0[iv]) goto label_280;
                 fprintf(fw," *** improvement on the local minimum no. %d : %14.8f for %14.8f",iv,f0[iv],ff);
                 for(ii=1;ii<=*nparm;ii++) {
                     w[ii] = y[ii]*maxx[ii]+minx[ii];
                 }
                 fprintf(fw,"\n %14.8g\n  ",ff);
                 for(ii=1;ii<=*nparm;ii++){;
                         fprintf(fw," %14.8g",w[ii]);
                     if(ii==5 || ii==10 || ii==15) fprintf(fw,"\n  ");
                 }
                 f0[iv]= ff;
                 for(ii=1;ii<=*nparm;ii++) {
                     (*x0)[ii][iv] =y[ii];
                 }
  label_280:     if (n1  > 20) goto label_470;
                 for(ii=1;ii<=*nparm;ii++) {
                     (*x1)[ii][n1] =(*x)[ii][i1];
                     (*xcl)[ii][1] =(*x)[ii][i1];
                 }
                 f1[n1]= f[i1];
                 fcl[1]= f[i1];
                 ic1[n1] = iv;
                 icj = iv;
                 goto label_305;
/*        NEW LOCAL MINIMUM                                              */
  label_290:     *nc = *nc+1;
                 ncp = ncp+1;
                 fprintf(fw, "\n *** the local minimum no. %d : %14.8g   nfev=%d",*nc,ff,nfe1);
               /*    printf("\n *** the local minimum no. %d : %14.8g   nfev=%d",*nc,ff,nfe1); */
                 for(ii=1;ii<=*nparm;ii++) {
                     w[ii] = y[ii]*maxx[ii]+minx[ii];
                 }
                 fprintf(fw,"\n %14.8g\n  ",ff);
               /*    printf("\n  X = "); */
                 for(ii=1;ii<=*nparm;ii++) {
                         fprintf(fw," %14.8g",w[ii]);
                       /*    printf(" %14.8g",w[ii]); */
                     if(ii==5 || ii==10 || ii==15) fprintf(fw,"\n  ");
				 }
				/*   printf("\n"); */
                 for(ii=1;ii<=*nparm;ii++) {
                     (*x0)[ii][*nc] =y[ii];
                     (*xcl)[ii][1] =y[ii];
                 }
                 fcl[1]= ff;
                 f0[*nc]= ff;
				 if (*nc >= MAXNC) goto label_475;
                 it = 1;
                 icj = *nc;
/*       CLUSTERING TO THE NEW POINT                                     */
  label_305:     *nfe = *nfe+nfe1;
                 ic[i1]= icj;
                 ig = ig+1;
                 if (ig >= ng) goto label_390;
                 i = 1;
                 in1 = i;
  label_310:     for(j=1;j<=ng;j++) {
                     if (ic[j] != 0) continue;
                     if (fcl[i] >= f[j]) continue;
                     for(l1=1;l1<=*nparm;l1++) {
                         w[l1] = fabs((*xcl)[l1][i]-(*x)[l1][j]);
                     }
                     a = zero;
                     for(l1=1;l1<=*nparm;l1++) {
                         if (w[l1]  > a) a=w[l1];
                     }
                     if (a >= b) continue;
                     in1 = in1+1;
                     for(ii=1;ii<=*nparm;ii++) {
                         (*xcl)[ii][in1]= (*x)[ii][j];
                     }
                     fcl[in1] = f[j];
                     ic[j] = icj;
                     fprintf(fw,"\n sample point added to the cluster no. %d",icj);
                     for(ii=1;ii<=*nparm;ii++) {
                         w[ii] = (*x)[ii][j]*maxx[ii]+minx[ii];
                     }
                         fprintf(fw,"\n %14.8g\n  ",f[j]);
                     for(ii=1;ii<=*nparm;ii++) {
                         fprintf(fw," %14.8g",w[ii]);
                         if(ii==5 || ii==10 || ii==15) fprintf(fw,"\n  ");
                     }
                     ig = ig+1;
                     if (ig >= ng) goto label_390;
                 }
                 i = i+1;
                 if (i  < in1) goto label_310;
             }
  label_390: if (it != 0) goto label_20;
/*         PRINT RESULTS                                                 */
  label_395: fprintf(fw, "\n\n\n\n local minima found: \n\n");
             if (*nc <= 1) goto label_430;
             inum = *nc-1;
             for(i=1;i<=inum;i++) {
                 im = i;
                 fm = f0[i];
                 inum1 = i+1;
                 for(j=inum1;j<=*nc;j++) {
                     if (f0[j] >= fm) continue;
                     im = j;
                     fm = f0[j];
                 }
                 if (im <= i) continue;
                 a = fm;
                 for(j=1;j<=*nparm;j++) {
                     y[j] = (*x0)[j][im];
                 }
                 inum1 = im-i;
                 for(j=1;j<=inum1;j++) {
                     inum2 = im-j;
                     f0[inum2+1]= f0[inum2];
                     for(jj=1;jj<=*nparm;jj++) {
                         (*x0)[jj][inum2+1] =(*x0)[jj][inum2];
                     }
                 }
                 f0[i] = a;
                 for(j=1;j<=*nparm;j++) {
                     (*x0)[j][i] = y[j];
                 }
             }
  label_430: if (*nc <= 0) goto label_445;
             for(i=1;i<=*nc;i++) {
                 for(ii=1;ii<=*nparm;ii++) {
                     (*x0)[ii][i] = (*x0)[ii][i]*maxx[ii]+minx[ii];
                 }
                 fprintf(fw,"\n F(x)= %14.8g\n  ",f0[i]);
                 fprintf(fw,"\n   X =");
                 for(ii=1;ii<=*nparm;ii++) {
                         fprintf(fw," %14.8g",(*x0)[ii][i]);
                     if(ii==5 || ii==10 || ii==15) fprintf(fw,"\n  ");
                 }
             }
  label_445: free(maxx);
             free(minx);
             free(y);
             free(w);
             free(r);
             free(xcl);
             free(x1);
             free(x);

             fprintf(fw,"\n\n normal termination after %d function evaluations \n\n",*nfe);
			 return 0;
  label_455: fprintf(fw," ***   too many parameters, abnormal termination");
             return 3;
  label_460: fprintf(fw,"  ***   data error");
             return 3;
  label_465: fprintf(fw," ***   too many sampling");
             goto label_395;
  label_470: fprintf(fw," ***   too many new seed points");
             goto label_395;
  label_475: fprintf(fw," ***   too many clusters");
             goto label_395;
}

/***************************************************************************/

void  fun(r,f,nparm,m,minx,maxx)
VEKTOR_n   r, minx, maxx;
double     *f;
int      *nparm, *m;
{
			 double x[20];		/* [200] volt */
			 int    i;

/*           if((x = (VEKTOR_n)malloc(sizeof(double)*(*nparm+1)))==NULL) exit(3);*/
             for(i=1;i<=*nparm;i++) {
                 x[i] =maxx[i]*r[i]+minx[i];
             }
	     (*aktfgv)(x,f,nparm,m);
/*           free(x); */
}

/***************************************************************************/

void urdmn(t,nparm)
TOMB_nx101 t;
int      *nparm;
{
        register int i,j;
        for(i=1;i<=100;i++)
           for(j=1;j<=*nparm;j++){
              (*t)[j][i]=duni_();
           }
}

