# callback must be imported before the caller function imported
# to initialize the correct userfn[BUF_SIZE] global buffer
from _callback import UserFunctions, setFn

cbk_err = "Callback Error:"

class callback:
    """
    class callback provides callback facility for Python and C/Fortran
functions. Pass
    cb = callback.callback('C/Fortran_Fun')
    or cb = callback.callback(Py_Fun, 'wrapper')
to the external function which supports callback
    """
    def __init__(self, funct, wrapper=None):
        if (wrapper == None):
            # Single value passed in -> C/Fortran function name
            try:
                (self.index, self.des) = UserFunctions[funct]
            except IndexError:
                raise cbk_err, "Invalid initialization, C/Fortran function not found"
            self.funct = funct
	else:
            # setting python callback
            try:
                (self.index, self.des) = UserFunctions[wrapper]
            except IndexError:
                raise cbk_err, "Invalid initialization, wrapper not found"
            self.funct = funct
            setFn(self.funct, self.index)








