      SUBROUTINE CUMSCA(N,W,DFDX)
C
C  CUMSCA  STORES CUMULATED STATISTICAL DATA ON THE ILL-CONDITIONING OF
C  F(AX+B) W.R.T. X
C
      DOUBLE PRECISION W,DFDX
      DOUBLE PRECISION DFDXMA
      DOUBLE PRECISION DIST,BIAS,GRAGRA,GRA
      COMMON /SCALE/ DIST(10,10,20),BIAS(10,20),GRAGRA(10,10,20),
     1    GRA(10,20),NGRA(20),LSCA,IDSCA,NX,NORD
      DIMENSION W(N)
      DATA DFDXMA/1.D8/
C
      IF(LSCA.LE.0)RETURN
      IF(DABS(DFDX).GT.DFDXMA)RETURN
      DO 1 I = 1,N
         DO 2 J = 1,N
            GRAGRA(I,J,IDSCA) = GRAGRA(I,J,IDSCA)+DFDX*W(I)*DFDX*W(J)
   2        CONTINUE
         GRA(I,IDSCA) = GRA(I,IDSCA)+DFDX*W(I)
   1     CONTINUE
      NGRA(IDSCA) = NGRA(IDSCA)+1
C
      RETURN
      END
