      SUBROUTINE GAUSRV(N,W)
C
C GENERATES A RANDOM VECTOR SAMPLE FROM AN N-DIMENSIONAL
C NORMAL DISTRIBUTION
C
      DOUBLE PRECISION W,X,Y,R
      DOUBLE PRECISION CHAOS
C
      DIMENSION W(N)
C
      NN = (N+1)/2
C
      DO 20 I = 1,NN
         II = 1+N-I
C
  10     CONTINUE
         X = CHAOS(-2)
         Y = CHAOS(-2)
         R = X*X+Y*Y
C
         IF(R.GT.1.D0) GO TO 10
C
         R = DSQRT(-2.D0*DLOG(R)/R)
C
         W(I) = X*R
         W(II) = Y*R
C
  20     CONTINUE
C
      RETURN
      END
