      INTEGER FUNCTION IPREC(ID1,ID2)
C
C  IPREC  DETERMINES THE PRECEDENCE RELATION BETWEEN TWO TRAJECTORIES
C  BASED ON THE PAST HISTORY DATA
C
      DOUBLE PRECISION VM1,VM2
      DOUBLE PRECISION X,H,DX,VMVT,EPS,VMCOR,VCOR
      DOUBLE PRECISION XRMIN,XRMAX,XOPT,FOPT
      COMMON /DINCOM/ X(100,20),H(20),DX(20),VMVT(20,19),EPS(20),
     1    VMCOR(20),VCOR(20),XRMIN(100),XRMAX(100),XOPT(100),FOPT,
     2    IE(20),ISVT(20,19),KGEN,KTIM,NDIM,NTRAJ,NTRAJR,
     3    ISEGBR,INKPBR,KPBR0,NCF,IFEP,INHP
C
      VM1 = VMVT(ID1,NTRAJR)
      VM2 = VMVT(ID2,NTRAJR)
      DO 10 IIT = 1,NTRAJR
         IT = 1+NTRAJR-IIT
         IF(ISVT(ID1,IT).EQ.ISVT(ID2,IT))GO TO 20
         VM1 = DMIN1(VM1,VMVT(ID1,IT))
         VM2 = DMIN1(VM2,VMVT(ID2,IT))
  10     CONTINUE
  20  CONTINUE
      IPREC = 0
      IF(VM2.LT.VM1)IPREC = ID2
      IF(VM2.GT.VM1)IPREC = ID1
C
      RETURN
      END
