      INTEGER FUNCTION ITOLCH(FMAX,FMIN,TOLREL,TOLABS)
C
C  ITOLCH  DETERMINES  WHETHER TWO QUANTITIES ARE TO BE CONSIDERED NU-
C  MERICALLY EQUAL WITH RESPECT TO AN ABSOLUTE (OR RELATIVE) DIFFERENCE
C  CRITERION, WITHIN GIVEN TOLERANCES
C
      DOUBLE PRECISION FMAX,FMIN,TOLREL,TOLABS
C
      ISTOP = 0
C
C CHECK RELATIVE DIFFERENCE AGAINST  TOLREL
      IF(DABS(FMAX-FMIN).LE.TOLREL*(DABS(FMIN)+DABS(FMAX))/2.D0)
     1    ISTOP=ISTOP+1
C
C CHECK ABSOLUTE DIFFERENCE AGAINST  TOLABS
      IF(FMAX-FMIN.LE.TOLABS)ISTOP = ISTOP+2
      ITOLCH = ISTOP
C
      RETURN
      END
