      SUBROUTINE REINIT(NX,X0,EPS0,IRAND,F,IFE)
C
C  REINIT  PERFORMS THE INITIALIZATION OF ALL TRIALS FOLLOWING THE
C  FIRST TRIAL, AND PART OF THE INITIALIZATION OF THE FIRST TRIAL.
C
      DOUBLE PRECISION X0,EPS0,F
      DOUBLE PRECISION EPSV,G
      DOUBLE PRECISION CHAOS
      DOUBLE PRECISION X,H,DX,VMVT,EPS,VMCOR,VCOR
      DOUBLE PRECISION XRMIN,XRMAX,XOPT,FOPT
      COMMON /DINCOM/ X(100,20),H(20),DX(20),VMVT(20,19),EPS(20),
     1    VMCOR(20),VCOR(20),XRMIN(100),XRMAX(100),XOPT(100),FOPT,
     2    IE(20),ISVT(20,19),KGEN,KTIM,NDIM,NTRAJ,NTRAJR,
     3    ISEGBR,INKPBR,KPBR0,NCF,IFEP,INHP
      DIMENSION X0(NX)
      DATA EPSV/1.D0/
C
C INITIALIZE RANDOM NOISE GENERATOR
C
      G = CHAOS(IRAND)
C
      IFEP = IFE
      KGEN = 0
      KTIM = 0
      DO 30 ID = 1,NTRAJ
         DO 10 IC = 1,NDIM
            X(IC,ID) = X0(IC)
  10        CONTINUE
         IE(ID) = 0
         DO 20 IT = 1,NTRAJR
            ISVT(ID,IT) = 1
            VMVT(ID,IT) = F
  20        CONTINUE
         EPS(ID) = EPS0*EPSV**(ISEGBR-ID)
         VMCOR(ID) = F
         VCOR(ID) = F
  30     CONTINUE
      RETURN
      END
